<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <title>&lt;t-rex-runner> Demo</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@shoelace-style/shoelace@2.0.0-beta.83/dist/themes/light.css" />
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@shoelace-style/shoelace@2.0.0-beta.83/dist/themes/dark.css" />
    <link rel="stylesheet" href="dev.css" />
    <script src="../node_modules/@webcomponents/webcomponentsjs/webcomponents-loader.js"></script>
    <script src="../node_modules/lit/polyfill-support.js"></script>
    <script type="module" src="../t-rex-runner.js"></script>     
    <script type="module" src="https://cdn.jsdelivr.net/npm/@shoelace-style/shoelace@2.0.0-beta.83/dist/shoelace.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/canvas-confetti@1.6.0/dist/confetti.browser.min.js"></script>
    <script>
      window.addEventListener('DOMContentLoaded', () => {
        const tRexRunner = document.querySelector('t-rex-runner');
        const soundSelect = document.querySelector('[data-select-key="sound"]');
        const spriteSelect = document.querySelector('[data-select-key="sprite"]');
        const themeSelect = document.querySelector('[data-select-key="theme"]');
        const pageTitle = document.querySelector('h1');

        soundSelect.addEventListener('sl-change', (e) => {
          tRexRunner.soundEffects = e.target.value;
        });

        spriteSelect.addEventListener('sl-change', (e) => {
          if (e.target.value === 'kirby') {
            tRexRunner.spriteSheet1x = 'assets/kirby_100_percent/100-offline-sprite.png';
            tRexRunner.spriteSheet2x = 'assets/kirby_200_percent/200-offline-sprite.png';
            pageTitle.textContent = 'Kirby Runner Web Component';
            return;
          }
          tRexRunner.spriteSheet1x = 'assets/default_100_percent/100-offline-sprite.png';
          tRexRunner.spriteSheet2x = 'assets/default_200_percent/200-offline-sprite.png';
          pageTitle.textContent = 'T-Rex Runner Web Component';
        });

        themeSelect.addEventListener('sl-change', (e) => {
          if (e.target.value === 'light') {
            document.querySelector('html').classList.remove('sl-theme-dark');
          } else {
            document.querySelector('html').classList.add('sl-theme-dark');
          }
        })

        tRexRunner.addEventListener('achievement', () => {
          var colors = spriteSelect.value === 'kirby' ? ['#ED628B', '#F193A7', '#F9CDD5'] : null;
          var count = 200;
          var defaults = {
            origin: { y: 0.7 }
          };

          function fire(particleRatio, opts) {
            confetti(Object.assign({}, defaults, opts, {
              colors,
              particleCount: Math.floor(count * particleRatio)
            }));
          }

          fire(0.25, {
            spread: 26,
            startVelocity: 55,
          });
          fire(0.2, {
            spread: 60,
          });
          fire(0.35, {
            spread: 100,
            decay: 0.91,
            scalar: 0.8
          });
          fire(0.1, {
            spread: 120,
            startVelocity: 25,
            decay: 0.92,
            scalar: 1.2
          });
          fire(0.1, {
            spread: 120,
            startVelocity: 45,
          });
        });
      });
    </script>
  </head>
  <body>
    <H1 class="page-header">T-Rex Runner Web Component</H1>
    <section class="runner-container">
      <t-rex-runner>
        <div class="config">
          <sl-select label="Sound Effects" value="default" data-select-key="sound">
            <sl-menu-item value="default">Default</sl-menu-item>
            <sl-menu-item value="kirby">Kirby</sl-menu-item>
          </sl-select>
          <sl-select label="Sprite Sheet" value="default" data-select-key="sprite">
            <sl-menu-item value="default">Default</sl-menu-item>
            <sl-menu-item value="kirby">Kirby</sl-menu-item>
          </sl-select>
          <sl-select label="Theme" value="light" data-select-key="theme">
            <sl-menu-item value="light">Light</sl-menu-item>
            <sl-menu-item value="dark">Dark</sl-menu-item>
          </sl-select>
        </div>
      </t-rex-runner>
    </section>
  </body>
</html>
